//------------------------------------------------------------------------------
// <auto-generated />
//
// This file was automatically generated by SWIG (http://www.swig.org).
// Version 3.0.12
//
// Do not make changes to this file unless you know what you are doing--modify
// the SWIG interface file instead.
//------------------------------------------------------------------------------

namespace OpenMMNET {

public class ThreeParticleAverageSite : VirtualSite {
  private global::System.Runtime.InteropServices.HandleRef swigCPtr;

  internal ThreeParticleAverageSite(global::System.IntPtr cPtr, bool cMemoryOwn) : base(OpenMMSwigPINVOKE.ThreeParticleAverageSite_SWIGUpcast(cPtr), cMemoryOwn) {
    swigCPtr = new global::System.Runtime.InteropServices.HandleRef(this, cPtr);
  }

  internal static global::System.Runtime.InteropServices.HandleRef getCPtr(ThreeParticleAverageSite obj) {
    return (obj == null) ? new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero) : obj.swigCPtr;
  }

  ~ThreeParticleAverageSite() {
    Dispose();
  }

  public override void Dispose() {
    lock(this) {
      if (swigCPtr.Handle != global::System.IntPtr.Zero) {
        if (swigCMemOwn) {
          swigCMemOwn = false;
          OpenMMSwigPINVOKE.delete_ThreeParticleAverageSite(swigCPtr);
        }
        swigCPtr = new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero);
      }
      global::System.GC.SuppressFinalize(this);
      base.Dispose();
    }
  }

  public ThreeParticleAverageSite(int particle1, int particle2, int particle3, double weight1, double weight2, double weight3) : this(OpenMMSwigPINVOKE.new_ThreeParticleAverageSite(particle1, particle2, particle3, weight1, weight2, weight3), true) {
  }

  public double getWeight(int particle) {
    double ret = OpenMMSwigPINVOKE.ThreeParticleAverageSite_getWeight(swigCPtr, particle);
    return ret;
  }

}

}
